image: node:latest
stages:
  - lint
  - test
  - deploy

cache:
  key: nodes
  paths:
    - node_modules/

lint:
  stage: lint
  cache:
    paths:
      - node_modules
    policy: pull
  script:
    - npm i
    - npm run lint

test:
  stage: test
  dependencies:
    - lint
  cache:
    paths:
      - node_modules
    policy: pull
  script:
    - npm i
    - npm run test
    - cp test-report.html /tmp/
  artifacts:
    paths:
      - test-report.html
    name: report-test
    when: on_success
    expire_in: 1 weeks

deploy:
  image: kroniak/ssh-client
  script:
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - echo "$SSH_PRIVATE_KEY" > ~/.ssh/id_rsa
    - chmod 600 ~/.ssh/id_rsa
    - mv /tmp/test-report.html /tmp/test-report-"`date +"%d-%m-%Y"`".html
    - ssh $SSH_USER@$SSH_SERVER_IP -p $SSH_PORT "mkdir -p $SSH_DIR/FME/$CI_PROJECT_NAME"
    - scp -r -P $SSH_PORT ./test-report.html $SSH_USER@$SSH_SERVER_IP:$SSH_DIR/FME/$CI_PROJECT_NAME/test-report-$(date +%Y%m%d).html
  stage: deploy
  dependencies:
    - test
